---
title: MessageEvent.MessageEvent()
slug: Web/API/MessageEvent/MessageEvent
tags:
  - API
  - Constructor
  - DOM
  - MessageEvent
  - Reference
  - messaging
---
<div>{{APIRef("HTML DOM")}}{{draft}}</div>

<p>The <strong><code>MessageEvent()</code></strong> constructor creates a new {{domxref("MessageEvent")}} object instance.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var messageEvent = new MessageEvent(<em>type, init</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><strong>type</strong></code></dt>
 <dd>The type of <code>MessageEvent</code> that will be created. This can be one of XXX</dd>
 <dt>
 <p><strong><code>init</code> </strong>{{optional_inline}}</p>
 </dt>
 <dd>
 <p>A dictionary object that can contain the following properties:</p>

 <ul>
  <li><code>data</code>: The data you want contained in the MessageEvent. This can be of any data type, and will default to <code>null</code> if not specified.</li>
  <li><code>origin</code>: A {{domxref("USVString")}} representing the origin of the message emitter. This defaults to an empty string ("") if not specified.</li>
  <li><code>lastEventId</code>: A {{domxref("DOMString")}} representing a unique ID for the event. This defaults to an empty string ("") if not specified.</li>
  <li><code>source</code>: An <code>MessageEventSource</code> (which can be a {{domxref("WindowProxy")}}, {{domxref("MessagePort")}}, or {{domxref("ServiceWorker")}} object) representing the message emitter. This defaults to <code>null</code> if not set.</li>
  <li><code>ports</code>: An array of {{domxref("MessagePort")}} objects representing the ports associated with the channel the message is being sent through (where appropriate, e.g. in channel messaging or when sending a message to a shared worker). This defaults to an empty array (<code>[]</code>) if not specified.</li>
 </ul>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">var myMessage = new MessageEvent('worker', {
  data : 'hello'
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "#dom-event-constructor", "MessageEvent()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MessageEvent.MessageEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("ExtendableMessageEvent")}} — similar to this interface but used in interfaces that needs to give more flexibility to authors.</li>
</ul>
